package com.aitrainer.api.controller

import com.aitrainer.api.model.Configuration

import com.aitrainer.api.repository.ConfigurationRepository
import org.springframework.web.bind.annotation.RestController
import java.time.LocalDateTime

@RestController
class ConfigurationController ( private val configurationRepository: ConfigurationRepository) {

    fun getConfiguration(key: String): Configuration =
            configurationRepository.findByConfigKey(key)

    fun updateConfiguration( newConfiguration: Configuration): Configuration {
        val existingConfiguration: Configuration = configurationRepository.findByConfigKey(newConfiguration.configKey)
            val updatedConfiguration: Configuration = existingConfiguration.copy(
                    configKey = newConfiguration.configKey,
                    configValue = newConfiguration.configValue,
                    //dateAdd = newConfiguration.dateAdd,
                    dateChange = LocalDateTime.now().toString())

            configurationRepository.save(updatedConfiguration)
        return existingConfiguration
    }

}
