package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class ExerciseDevice (
        @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY)  val exerciseDeviceId: Long = 0,

        @Expose  @get: NotBlank var name: String = "",
        @Expose var description: String?,
        @Expose var imageUrl: String?,
        @Expose @get: NotBlank var sort: Int = 0,
        @Expose  @get: NotBlank var place: Int = 0
){
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseDevice")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val translations: List<ExerciseDeviceTranslation> = mutableListOf<ExerciseDeviceTranslation>().toList()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseDevice")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val alternatives: List<ExerciseDeviceAlternative> = mutableListOf<ExerciseDeviceAlternative>().toList()
}
