package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.FetchMode
import org.hibernate.annotations.Fetch
import org.springframework.lang.NonNull
import javax.persistence.*
import javax.validation.constraints.NotBlank
import javax.validation.constraints.Null

@Entity
data class ExerciseType(

        @Expose @get: NotBlank var name: String = "",
        @Expose @get: NotBlank var description: String = "",
        @Expose @get: Null var unit: String?,
        @Expose @get: Null var unitQuantity: String?,
        @Expose @get: Null var unitQuantityUnit: String?,
        @Expose @get: NonNull var active: Boolean?,
        @Expose @get: NonNull var base: Boolean?,

        @Expose @Id @GeneratedValue(strategy = GenerationType.IDENTITY)  val exerciseTypeId: Long = 0,

) {
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseType")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val images: List<ExerciseTypeImage> = mutableListOf()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseType")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val translations: List<ExerciseTypeTranslation> = mutableListOf()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseType")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val alternatives: List<ExerciseTypeAlternative> = mutableListOf()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseType")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val parents: List<ExerciseTypeParents> = mutableListOf()

        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "exerciseType")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val devices: List<ExerciseTypeDevice> = mutableListOf()
}
