package com.aitrainer.api.service

import org.springframework.beans.factory.annotation.Value
import org.springframework.core.env.Environment
import org.springframework.stereotype.Service

@Service
class PropertyServiceForJasyptStarter {
    @Value("\${trust.store.password}")
    val storePassword: String? = null


   @Value("\${server.ssl.key-store-password}")
   val keyStorePassword: String? = null


    fun getPasswordUsingEnvironment(environment: Environment): String? {
        return environment.getProperty("trust.store.password")
    }

    fun getKeyStorePasswordUsingEnvironment(environment: Environment): String? {
        return environment.getProperty("server.ssl.key-store-password")
    }
}